//|                                                    1H   EUR/USD  |
//|                                                    Smirnov Pavel |
//|                                                 www.autoforex.ru |
//+------------------------------------------------------------------+

#property copyright "2012"
#property link      "www.autoforex.ru"

extern int TakeProfit_L = 400; //    
extern int StopLoss_L = 1330;  //    
extern int TakeProfit_S = 270; //    
extern int StopLoss_S = 2000;  //    
extern int TradeTime=18;      //    
extern int t1=7;
extern int t2=2;
extern int delta_L=9;
extern int delta_S=10;
extern double lot = 0.1;      //  
extern int Orders=1;          //     
extern int MaxOpenTime=138;

int ticket,total,cnt;
bool cantrade=true;
double closeprice;
double tmp;

int OpenLong(double volume=0.1)
//      =volume 
{
  int slippage=10;
  string comment="20/200 expert v2 (Long)";  
  color arrow_color_Buy=Blue;
  int magic=0;

  ticket=OrderSend(Symbol(),OP_BUY,volume,Ask,slippage,Ask-StopLoss_L*Point,
                      Ask+TakeProfit_L*Point,comment,magic,0, arrow_color_Buy);
  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
    {
      return(0);
    }
    else
      {
        Print("OpenLong(),OrderSelect() -   : ",GetLastError());
        return(-1);
      }
  }
  else
  {
    Print("Error opening Buy order : ",GetLastError());
    return(-1);
  }
}

int OpenShort(double volume=0.1)
//      =volume
{
  int slippage=10;
  string comment="20/200 expert v2 (Short)";
 color arrow_color_Sell=Red;
  int magic=0;

  ticket=OrderSend(Symbol(),OP_SELL,volume,Bid,slippage,Bid+StopLoss_S*Point,
                      Bid-TakeProfit_S*Point,comment,magic,0,arrow_color_Sell);
  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
    else
      {
        Print("OpenShort(),OrderSelect() -   : ",GetLastError());
        return(-1);
      }
  }
  else
  {
    Print("Error opening Sell order : ",GetLastError());
    return(-1);
  }
}

int init()
{
  return(0);
}

int deinit()
{
  return(0);
}

int start()
{
  if((TimeHour(TimeCurrent())>TradeTime)) cantrade=true;
  //      ...
  total=OrdersTotal();
  if(total<Orders)
  {
    // ...      ,   
    //      
    if((TimeHour(TimeCurrent())==TradeTime)&&(cantrade))
    {
      // ...   , 
      if (((Open[t1]-Open[t2])>delta_S*Point)) //     delta
      {
        //      :
        //         
        if(AccountFreeMarginCheck(Symbol(),OP_SELL,lot)<=0 || GetLastError()==134)
        {
          Print("Not enough money");
          return(0);
        }
        OpenShort(lot);

        cantrade=false; //     
        return(0);
      }
      if (((Open[t2]-Open[t1])>delta_L*Point)) //     delta
      {
        //       
        //       
        if(AccountFreeMarginCheck(Symbol(),OP_BUY,lot)<=0 || GetLastError()==134)
        {
          Print("Not enough money");
          return(0);
        }
        OpenLong(lot);
        cantrade=false;
        return(0);
      }
    }
  }
//     ,  MaxOpenTime=0,    .
  if(MaxOpenTime>0)
  {
    for(cnt=0;cnt<total;cnt++)
    {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
         tmp = (TimeCurrent()-OrderOpenTime())/3600.0;
         if (((NormalizeDouble(tmp,8)-MaxOpenTime)>=0))
        {
          RefreshRates();
          if (OrderType()==OP_BUY)
            closeprice=Bid;
          else
            closeprice=Ask;
          if (OrderClose(OrderTicket(),OrderLots(),closeprice,10,Green))
          {
            Print("   - ",OrderTicket());
            OrderPrint();
          }
          else
            Print("OrderClose()         - ",GetLastError());
        }
      }
      else
        Print("OrderSelect()         - ",GetLastError());
    }
  }
  return(0);
}